#!/bin/bash

while [ true ]

do

# it is recommended to put delay at beginning of the script instead of the end
sleep 3

#-----------------------------------------------------------------------------------------------------
# Check to see if projector needs turned on or off

#NOTE When script is run within UserCallbackHook, files are saved/read to /opt/fpp
#     When script is run manually via command prompt, files are saved/read where the script is run from (~/media/scripts)

#get current day & time
DD=$(date +%d)
HH=$(date +%H)
MM=$(date +%M)

#Is it time to turn ON projector? (6:00 p.m.)
if [ $HH -eq 18 ] && [ $MM -eq 0 ]
  then

  #time is correct, has it already been turned on?

  #read stored day

  #if file does not exist, create it
  FILE=projectorOnDay.txt
  if [[ ! -f "$FILE" ]]; then
  echo "0" > projectorOnDay.txt
  fi

  STD=$(cat projectorOnDay.txt)

  #echo "Today is the $DD"
  #echo "Hour is $HH"
  #echo "Minute is $MM"
  #echo "Stored ON day is $STD"

  #if stored day is different than current day, turn on projector and store new day in file

  if [ $DD -ne $STD ]
    then
    echo "---"
    echo "Turning ON projector on $(date)"
    echo "---"

    sudo chmod 666 /dev/ttyUSB0
    echo -en '\x43\x30\x30\x0D' > /dev/ttyUSB0

    echo $DD > projectorOnDay.txt
  fi
fi

#Is it time to turn OFF projector? (11:30 p.m.)
if [ $HH -eq 23 ] && [ $MM -eq 30 ]
  then

  #time is correct, has it already been turned off?

  #read stored day

  #if file does not exist, create it
  FILE=projectorOffDay.txt
  if [[ ! -f "$FILE" ]]; then
  echo "0" > projectorOffDay.txt
  fi

  STD=$(cat projectorOffDay.txt)

  #echo "Today is the $DD"
  #echo "Hour is $HH"
  #echo "Minute is $MM"
  #echo "Stored OFF day is $STD"

  #if stored day is different than current day, turn on projector and store new day in file

  if [ $DD -ne $STD ]
    then
    echo "---"
    echo "Turning OFF projector on $(date)"
    echo "---"

    sudo chmod 666 /dev/ttyUSB0
    echo -en '\x43\x30\x31\x0D' > /dev/ttyUSB0

    echo $DD > projectorOffDay.txt
  fi
fi

#--------------------------------------------------------------------------------------------------
#Run dynamic playlist repeatedly

		# Get our current status
		STATUS=$(fpp -s | cut -d',' -f2)

		# Check that we got something meaningful
		if [ -z "${STATUS}" ]; then
			echo "Error with status value" >&2
			exit 1
		fi

		# Act on the current status
		case ${STATUS} in
			# IDLE
			0)
			fpp -P "Dynamic"
			;;

			# Playlist is currently running, so do nothing
			1)
			;;

			# User stops playlist gracefully, so stop this script from looping (end script)
			2)
			break
			;;
		esac
done
